﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Windows.Forms.DataVisualization.Charting;
using System.IO;
using System.IO.Ports;
using System.Text;
using System.Globalization;


namespace BiteForceMeasurementDevice
{
    public partial class Exp_Control_GUI : Form
    {
        List<string> recList = new List<string>();
        String[] tmp;
        String time;
        String tmpRead;
        Double maxRead = 0;


        public Exp_Control_GUI()
        {
            InitializeComponent();
            this.CenterToParent();
            BtnCon.Enabled = false;
            BtnCon.BringToFront();

            BtnDiscon.Enabled = false;
            BtnDiscon.SendToBack();          
            TextPath.Text = "C:\\Experiments\\BiteForceMeasurementDevice\\Data";
            textBox_Subject.Text = "No name";
            label_ForceMax.Text = "0";

            Chart1.Series[0].Name = "Force";
            Chart1.Series["Force"].XValueType = ChartValueType.DateTime;
            Chart1.Series["Force"].ChartType = SeriesChartType.Line;
            Chart1.Series["Force"].IsValueShownAsLabel = false;
            Chart1.ChartAreas["ChartArea1"].AxisX.Enabled = AxisEnabled.False;
            Chart1.ChartAreas["ChartArea1"].AxisY.Interval = 50;

        }

        private void BtnPath_Click(object sender, EventArgs e)
        {

            folderBrowserDialog1.Description = "Select root folder";
            folderBrowserDialog1.SelectedPath = TextPath.Text;
            folderBrowserDialog1.ShowDialog();
            TextPath.Text = folderBrowserDialog1.SelectedPath;
        }

        private void TextPath_TextChanged(object sender, EventArgs e)
        {

        }

        private void BtnScanPort_Click(object sender, EventArgs e)
        {
            List<String> tList = new List<String>();

            CmbPort.Items.Clear();

            foreach (string s in SerialPort.GetPortNames())
            {
                tList.Add(s);
            }

            tList.Sort();
            CmbPort.Items.Add("Select COM port...");
            CmbPort.Items.AddRange(tList.ToArray());
            CmbPort.SelectedIndex = 0;
            BtnCon.Enabled = true;
            BtnCon.BringToFront();
            CmbPort.DroppedDown = true;
            
        }

        private void BtnCon_Click(object sender, EventArgs e)
        {

            String d;
            String m;
            String y;
            String min;
            String hour;
            String folderName;
            String pathName;
            String[] temp;
            String[] data;
            String[] time;
            String tmpstr;
            
            temp = DateTime.Now.ToString().Split(' ');
            data = temp[0].Split('/');
            time = temp[1].Split(':');
            d = data[0];
            m = data[1];
            y = data[2];
            hour = time[0];
            min = time[1];
            folderName = y + m + d + hour + min;
            pathName = TextPath.Text + "\\" + folderName;
            if (!System.IO.Directory.Exists(pathName))
            {
                System.IO.Directory.CreateDirectory(pathName);
            }
            else
            {
                MessageBox.Show("Folder already exist!!!");
            }
            System.IO.Directory.SetCurrentDirectory(pathName);
            TextPath.Text = pathName;

            BtnCon.Enabled = false;
            BtnCon.SendToBack();

            tmpstr = "Subject: " + textBox_Subject.Text;
            recList.Add(tmpstr);
            tmpstr = "Date: " + temp[0] + " Time: " + temp[1];
            recList.Add(tmpstr);
            //tmpstr = "Timer: " + textBox_Timer.Text;
            

            SerialPort1.BaudRate = 9600;//Int32.Parse(CmbBaud.Text);
            SerialPort1.PortName = CmbPort.SelectedItem.ToString();
            SerialPort1.Open();
            SerialPort1.DiscardOutBuffer();
            SerialPort1.DiscardInBuffer();

            BtnDiscon.Enabled = true;
            BtnDiscon.BringToFront();
            

            tmpRead = SerialPort1.ReadLine();
            Timer1.Start();

            BtnDiscon.Enabled = true;
            BtnDiscon.BringToFront();
        }

        private void CmbBaud_SelectedIndexChanged(object sender, EventArgs e)
        {

        }

        private void BtnDiscon_Click(object sender, EventArgs e)
        {
            BtnDiscon.Enabled = false;
            BtnDiscon.SendToBack();
            SerialPort1.DiscardOutBuffer();
            SerialPort1.DiscardInBuffer();
            SerialPort1.Close();
            
            for (int indx = 0; indx < recList.Count; indx ++)
            {
                File.WriteAllLines(TextPath.Text + "\\Data.txt", recList);
            }


            BtnCon.Enabled = true;
            BtnCon.BringToFront();
        }
        int i = 0;
        private void Timer1_Tick(object sender, EventArgs e)
        {
            try
            {
                    i++;
                        tmpRead = SerialPort1.ReadLine();
                        recList.Add(tmpRead);

                        tmp = tmpRead.Split('\r');
                        tmp = tmp[0].Split(',');
                        time = tmp[0];
                        tmp[0] = tmp[1];

                        var format = new NumberFormatInfo();
                        format.NegativeSign = "-";
                        format.NumberDecimalSeparator = ".";

                        var tmpVar = Double.Parse(tmp[0], format); // -14.3
                        
                
                        if (tmpVar > maxRead)
                        {
                            maxRead = tmpVar;
                        }
                        if (maxRead > 100)
                        {
                            Chart1.ChartAreas["ChartArea1"].AxisY.Interval = 100;
                        }

                        label_ForceMax.Text = maxRead.ToString();
                        LblForceSensor.Text = "Recorded Force: " + tmp[0];
                    
                        this.Chart1.Series["Force"].Points.AddY(tmp[0]);
                        if (this.Chart1.Series["Force"].Points.Count == 100)
                        {
                            this.Chart1.Series["Force"].Points.RemoveAt(0);
                        }

            }
            catch {

            }
        }

        private void label2_Click(object sender, EventArgs e)
        {

        }

        private void Exp_Control_GUI_Load(object sender, EventArgs e)
        {

        }

        private void label2_Click_1(object sender, EventArgs e)
        {

        }


        private void textBox_Time_TextChanged(object sender, EventArgs e)
        {

        }

        private void textBox_Subject_TextChanged(object sender, EventArgs e)
        {

        }

        private void label_Timer1_Click(object sender, EventArgs e)
        {

        }

        private void label_ForceMax_Click(object sender, EventArgs e)
        {

        }

        private void CmbPort_SelectedIndexChanged(object sender, EventArgs e)
        {

        }
    }
}
